/********************************************************************
 * NOTE: This source code is free and comes 
 * with ABSOLUTELY NO WARRANTY.
 * 
 * @author		Daniel Muenter
 * @contributor Christoph Buck
 *
 * 2006
 *  
 ********************************************************************/

const windowMediatorIID = Components.interfaces.nsIWindowMediator;
const windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(windowMediatorIID);
const prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
const promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
const profileDirectory = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsILocalFile);
const ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
const secretDecoderRing = Components.classes["@mozilla.org/security/sdr;1"].getService(Components.interfaces.nsISecretDecoderRing);
const inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"];
const converterInputStream = Components.classes["@mozilla.org/intl/converter-input-stream;1"];
const scriptableInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"];
const outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"];
const converterOutputStream = Components.classes["@mozilla.org/intl/converter-output-stream;1"];
const cService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

var regexStringBundle = null;
var chrome = 'chrome://feedbackfox/skin/icon';
// global variables
var topWin = null;
var optWnd = null;
var browser = null;
var numberOfPages = 1;
var statePanel = null;
var fbUrl = "";
var receivedUrl = "http://feedback.ebay.com/ws/eBayISAPI.dll?ViewFeedback2&userid=";
var leftUrl = "http://feedback.ebay.com/ws/eBayISAPI.dll?ViewFeedback2&ftab=FeedbackLeftForOthers&userid=";
var pagesContent = "";
var fbCount = 0;
var http_request_content = false;
var type = "";
var firstPageProcessed = false;
var allFinished = false;
var currentPage = 1;
var itemTab = null;
var contextMenu = null;
var locked = false;
var username = "";
var tmp = "";
var gChromeState = {};
var sidebar = "";
var sidebarBox = "";
var sidebarCurrentTitle = "";
var textfield = null;
var isItemView = false;
var aTab = "";
var progress = null;
var aCommandID = null;
var element = null;
var userid = "";
var maxfeedbackcount = 1000;
var currentDirection = "received";
var characteristic = "sellbuy";
// internationalization string variables
var locale = "";
var nouserid = "";
var noitemview = "";
var seller = "";
var buyer = "";
var leftby = "";
var leftfor = "";
var privateAuction = "";
var itemnotavailable = "";
var load = "";
var loadingerror = "";
var oneFb = "";
var moreThanOneFB = "";
var no = "";
// types
var positive = "";
var neutral = "";
var negative = "";
var withdrawn = "";
// localized month
var jan = "";
var feb = "";
var mar = "";
var apr = "";
var may = "";
var jun = "";
var jul = "";
var aug = "";
var sep = "";
var oct = "";
var nov = "";
var dec = "";
// localized day
var mon = "";
var tue = "";
var wed = "";
var thu = "";
var fri = "";
var sat = "";
var sun = "";
// date
var days = "";
var months = "";
// a variable for the top level domain extension
var tld = "";

function init() {	
	
	window.removeEventListener('load', init, false);
	topWin = windowMediator.getMostRecentWindow("navigator:browser");
	browser = topWin.getBrowser();
	try {
		var mfc = prefService.getCharPref("extensions.feedbackfox.maxfeedbackcount");
		maxfeedbackcount = parseInt(mfc);
	} catch(e) {
		log("init: " + e);
	}
	return true;
}

function log(aMessage) {
	cService.logStringMessage("Feedbackfox: " + aMessage);
}

function notify(msg) {
	growlNotify(msg);
}

function prepareMenu(menu) {
	
	while(menu.firstChild) {
		menu.removeChild(menu.firstChild);
	}
	var userList = new Array();
	var name = "";
	var links = null;
	var tabDoc = content.document;
	if(tabDoc.URL.match(/ebay.+ViewItem/)) {
		links = tabDoc.links;
	} else if(tabDoc.URL.match(/ebay.+ViewBids/)) {
		links = tabDoc.links;
	}
	if(links) {
		for(var i = 0; i < links.length; i++) {
			var li = String(links[i]);
			name = li.match(/http:\/\/myworld.ebay.\S+\/(\S+)\//);
			if(name != null) {
				name = name[1];
				name = String(name);
				if(!containsName(userList, name)) {
					userList.push(name);
				}
			}
		}
		userList.sort();
		while(userList.length > 0) {
			name = userList.shift();
			var item = document.createElement('menuitem');
			item.setAttribute('label', name);
			item.setAttribute('oncommand', "invokeContextMenuEvent('viewfeedbackfoxSidebar',label);");
			menu.appendChild(item);
		}
	}
}

function containsName(array, string) {
	
	for(var i = 0; i < array.length; i++) {
		if(array[i] == string) {
			return true;
		}
	}
	return false;
}

function registerContextMenuListener() {
	
	var context = document.getElementById("contentAreaContextMenu");
	if(context) {
		context.addEventListener("popupshowing", updateContextMenu, true);
	}
}

function updateContextMenu() {

	topWin = windowMediator.getMostRecentWindow("navigator:browser");
	browser = topWin.getBrowser();
	aTab = browser.selectedTab;
	var feedbackfoxmenuitem = document.getElementById("feedbackfox-menuitem");
	var tabDoc = content.document;
	if(tabDoc.URL.match(/ebay.+ViewItem/)) {
		feedbackfoxmenuitem.hidden = false;
		isItemView = true;
	} else if(tabDoc.URL.match(/ebay.+ViewBids/)) {
		feedbackfoxmenuitem.hidden = false;
		isItemView = true;
	} else {
		feedbackfoxmenuitem.hidden = true;
		isItemView = false;
	}
}

function invokeContextMenuEvent(command, name) {
	
	aCommandID = command;
	username = name;
	window.setTimeout("processContextMenuEvent()", 10);
}

function processContextMenuEvent() {
	
	reset();
	sidebar = document.getElementById("sidebar");
	sidebarBox = document.getElementById("sidebar-box");
	sidebarCurrentTitle = document.getElementById("sidebar-title").getAttribute("value");
	gChromeState.sidebarOpen = !sidebarBox.hidden;
	var state_on = (sidebarCurrentTitle == "Feedbackfox");
	if(!gChromeState.sidebarOpen || !state_on) {
		sidebarBox.setAttribute('src', 'chrome://feedbackfox/content/sidebar.xul');
		toggleSidebar(aCommandID);
		sidebar.addEventListener('load', getUserFeedback, true);
	} else {
		window.setTimeout("getUserFeedback()", 10);
	}
	toggleSidebar('viewAdblockPlusSidebar');
}

function getUserFeedback() {

	sidebar.removeEventListener('load', getUserFeedback, true);
	textfield = sidebar.contentDocument.getElementById("username-field");
	textfield.value = "";
	textfield.value = username;
	var receivedButton = sidebar.contentDocument.getElementById('receivedButton');
	receivedButton.doCommand();
}

function getSellerName() {
	
	var itemContent = "";
	var tabDoc = content.document;
	if(tabDoc.URL.match(/ebay.+ViewItem/)) {
		var itemURL = tabDoc.URL;
		http_request_content = new XMLHttpRequest();
		http_request_content.open('GET', itemURL, false);
		http_request_content.send(null);
		if (http_request_content.readyState == 4) {
			if(http_request_content.status == 200) {
				itemContent = http_request_content.responseText;
				var elements = itemContent.match(/sellerid=(\S+)&amp.ru=http/);
				username = elements[1];
			}
		}
	}
}

/* causes the feedbackfox-sidebar input objects are locked */
function lock() {
	
	if(!locked) {
	    var fbftreecols = document.getElementById('fbftreecols').childNodes;
	    for (var i = 0; i < fbftreecols.length; i++) {
	        var child = fbftreecols[i];
	        child.removeAttribute('onclick');
	    }
		var receivedButton = document.getElementById("receivedButton");
		receivedButton.disabled = true;
		var leftButton = document.getElementById("leftButton");
		leftButton.disabled = true;
		var feedbackfoxmenuitem = document.getElementById("feedbackfox-menuitem");
		if(isItemView) {
			feedbackfoxmenuitem.disabled = true;
		}
	}
	locked = true;
}

/* causes the feedbackfox-sidebar input objects are unlocked */
function unlock() {
	
	if(locked) {
		var receivedButton = document.getElementById("receivedButton");
		receivedButton.disabled = false;
		var leftButton = document.getElementById("leftButton");
		leftButton.disabled = false;
		var feedbackfoxmenuitem = document.getElementById("feedbackfox-menuitem");
		if(isItemView) {
			feedbackfoxmenuitem.disabled = false;
		}
		var fbftreecols = document.getElementById('fbftreecols').childNodes;
		for (var i = 0; i < fbftreecols.length; i++) {
		    var child = fbftreecols[i];
		    child.setAttribute('onclick', 'sortcolumn(this);');
		}
	}
	locked = false;
}

function processClickEvent(object) {
	
	element = object;
	if(element.id == 'posButton') {
		element.image = chrome + 'Poshover_16x16.gif';
	} else if(element.id == 'neuButton') {
		element.image = chrome + 'Neuhover_16x16.gif';
	} else if(element.id == 'negButton') {
		element.image = chrome + 'Neghover_16x16.gif';
	}
	window.setTimeout("resetButton(element)", 300);
}

function resetUsernameField() {
	document.getElementById("username-field").value = "";
	unlock();
}

function resetButton(element) {
	
	if(element.id == 'posButton') {
		element.image = chrome + 'Pos_16x16.gif';
	} else if(element.id == 'neuButton') {
		element.image = chrome + 'Neu_16x16.gif';
	} else if(element.id == 'negButton') {
		element.image = chrome + 'Neg_16x16.gif';
	}
	element = null;
}

function start(element, detail, direction) {
	
	textfield = document.getElementById("username-field");
	var olduserid = userid;
	userid = textfield.value;
	
	if(userid == olduserid && direction == currentDirection) {
		showAll();
	} else {
		reset();
		currentDirection = direction;
		processClickEvent(element);
        getLocalizedStrings();
		lock();
		switchStatePanel('progress');
		setProgressbar('0');
		var table = document.getElementById('list');
		table.removeEventListener('select', processRowSelection, false);
		reset();
		table.addEventListener('select', processRowSelection, false);
		
		if(!userid.match(/\S+/)) {
			var tabDoc = content.document;
			if(tabDoc.URL.match(/ebay.+ViewItem/)) {
				username = "";
				getSellerName();
				if(username.length > 1) {
					textfield.value = username;
					username = "";
					start(null,'all','received');
				}
			} else {
				setState(nouserid);
				unlock();
				window.setTimeout("setState()", 1000);
			}
		} else if(userid.match(/\S+/)) {
			if (direction == 'received') {
				document.getElementById('left').setAttribute('label', leftby);
				fbUrl = receivedUrl + userid;
			}
			else {
				document.getElementById('left').setAttribute('label', leftfor);
				fbUrl = leftUrl + userid;
			}
			type = detail;
			getContent(fbUrl);
		}
	}
}

function getLocalizedStrings() {

		var stringBundle = document.getElementById("string-bundle");
		// general strings
		locale = prefService.getCharPref("general.useragent.locale");
		nouserid = stringBundle.getString('nouserid');
		noitemview = stringBundle.getString('noitemview');
		itemnotavailable = stringBundle.getString('itemnotavailable');
		load = stringBundle.getString('load');
	 	loadingerror = stringBundle.getString('loadingerror');
	 	oneFb = stringBundle.getString('oneFb');
	 	moreThanOneFB = stringBundle.getString('moreThanOneFB');
		no = stringBundle.getString('no');
		// feedback types
		positive = stringBundle.getString('positive');
		neutral = stringBundle.getString('neutral');
		negative = stringBundle.getString('negative');
		withdrawn = stringBundle.getString('withdrawn');
		// seller and buyer
		seller = stringBundle.getString('seller');
		buyer = stringBundle.getString('buyer');
		leftby = stringBundle.getString('leftby');
		leftfor = stringBundle.getString('leftfor');
		privateAuction = stringBundle.getString('private');
		// date related strings
		jan = stringBundle.getString('jan');
		feb = stringBundle.getString('feb');
		mar = stringBundle.getString('mar');
		apr = stringBundle.getString('apr');
		may = stringBundle.getString('may');
		jun = stringBundle.getString('jun');
		jul = stringBundle.getString('jul');
		aug = stringBundle.getString('aug');
		sep = stringBundle.getString('sep');
		oct = stringBundle.getString('oct');
		nov = stringBundle.getString('nov');
		dec = stringBundle.getString('dec');
		mon = stringBundle.getString('mon');
		tue = stringBundle.getString('tue');
		wed = stringBundle.getString('wed');
		thu = stringBundle.getString('thu');
		fri = stringBundle.getString('fri');
		sat = stringBundle.getString('sat');
		sun = stringBundle.getString('sun');
		// organize them for easy access
		days = new Array(sun,mon,tue,wed,thu,fri,sat);
        months = new Array(jan,feb,mar,apr,may,jun,jul,aug,sep,oct,nov,dec);
}

function getTLD() {
	
	locale = prefService.getCharPref("general.useragent.locale");
	locale = (locale.length > 2) ? locale.substring(3).toLowerCase() : locale.toLowerCase();
	switch (locale) {
		case "at":
			tld = "at";
			break;
		case "ch":
			tld = "ch";
			break;
		case "de":
			tld = "de";
			break;
		case "au":
			tld = "com.au"
			break;
		case "ca":
			tld = "ca";
			break;
		case "gb":
			tld = "co.uk";
			break;
		case "ie":
			tld = "ie";
			break;
		case "in":
			tld = "in";
			break;
		case "sg":
			tld = "com.sg";
			break;
		case "es":
			tld = "es";
			break;
		case "it":
			tld = "it";
			break;
		case "fr":
			tld = "fr";
			break;
		case "be":
			tld = "be";
			break;
		case "nl":
			tld = "nl";
			break;
		case "pl":
			tld = "pl";
			break;
		case "cn":
			tld = "com.cn";
			break;
		default:
			tld = "com";
			break;
	}
	return tld;
}

function generateStateMessage(detail) {

	if(allFinished) {
		if(fbCount == 1) {
			if(detail == 'positive') {
				label = positive;
			} else if(detail == 'neutral') {
				label = neutral;
			} else if(detail == 'negative') {
				label = negative;
			} else if(detail == 'withdrawn') {
				label = withdrawn;
			} else {
				label = '';
			}
			setState("1 " + label + " " + oneFb);
		} else {
			if(detail == 'positive') {
				label = positive;
			} else if(detail == 'neutral') {
				label = neutral;
			} else if(detail == 'negative') {
				label = negative;
			} else if(detail == 'withdrawn') {
				label = withdrawn;
			} else {
				label = '';
			}
			setState(fbCount + " " + label + " " + moreThanOneFB);
		}
		unlock();
	}
}

function getNumberOfPages(content) {
	
	var found = false;
	regexStringBundle = document.getElementById("fbf-regex-bundle");
	var com = regexStringBundle.getString('numberofpages');
	com = new RegExp(com);
	try {
		var tmp = null;
		tmp = content.match(com)[1];
		tmp = tmp.replace(/\,/,"");
		numberOfPages = parseInt(tmp);
		if(numberOfPages) {
			found = true;
			try {
				var mfc = prefService.getCharPref("extensions.feedbackfox.maxfeedbackcount");
				maxfeedbackcount = parseInt(mfc);
			} catch(e) {}
			var maxNumber = Math.ceil(maxfeedbackcount / 25);
			if(numberOfPages > maxNumber) {
				numberOfPages = maxNumber;
			}
		}
	} catch(e) {
		log("getNumberOfPages: " + e);
		setState(loadingerror);
		unlock();
	}
	if(found) {
		return true;
	} else {
		return false;
	}
}

function getNextPage(type) {
	
	if(numberOfPages > currentPage) {
		++currentPage;
		var myHref = fbUrl + "&page=" + currentPage;
		getContent(myHref);
	} else {
		allFinished = true;
		generateStateMessage(type);
	}
	return true;
}

function getContent(myHref) {

	http_request_content = new XMLHttpRequest();
	http_request_content.timeout = 3; // 3 seconds
	http_request_content.onreadystatechange = processContent;
	http_request_content.open('GET', myHref, true);
	http_request_content.send(null);
}

function processContent() {
	
	var contentDoc = "";
	try {
		if (http_request_content.readyState == 4) {
			if(http_request_content.status == 200) {
				contentDoc = http_request_content.responseText;
				if(contentDoc) {
					if(!firstPageProcessed) {
						// look for number of pages we have to get
						getNumberOfPages(contentDoc);
						firstPageProcessed = true;
					}
					var ready = extractComments(contentDoc);
					if(ready) {
						var value = 100 / numberOfPages * currentPage;
						setProgressbar(value + "");
						getNextPage();
					}
				}
	 		}
		}
	} catch(e) {
		log("processContent: " + e);
	}
}

function extractComments(page) {

var detail = "";
var userLeft = "";
var sellbuy = "";
var date = "";
var comment = "";
var link = "";
var item = "";
var sorttype = 0;
regexStringBundle = document.getElementById("fbf-regex-bundle");
var header = regexStringBundle.getString('header');
header = new RegExp(header);
var trreg = regexStringBundle.getString('trreg');
trreg = new RegExp(trreg,"g");
var tablebegin = regexStringBundle.getString('tablebegin');
tablebegin = new RegExp(tablebegin);
var tableclass = regexStringBundle.getString('tableclass');
tableclass = new String(tableclass);
var tdreg = regexStringBundle.getString('tdreg');
tdreg = new RegExp(tdreg,"g");
characteristic = prefService.getCharPref("extensions.feedbackfox.characteristic");
try {
	log(page.indexOf(tableclass));
	var table = page.substring(page.indexOf(tableclass));
	var rows = table.match(trreg);
	for(var i = 0; i < rows.length; i++) {
		if(i < maxfeedbackcount) {
			var row = rows[i];
			row = row.replace(header,"");
			var rowreplpre = regexStringBundle.getString('rowreplpre');
			rowreplpre = new RegExp(rowreplpre);
			var rowreplpost = regexStringBundle.getString('rowreplpost');
			rowreplpost = new RegExp(rowreplpost);
			row = row.replace(rowreplpre,"").replace(rowreplpost,"");
			var td = row.match(tdreg);
			var detailregex = regexStringBundle.getString('detailregex');
			detailregex = new RegExp(detailregex);
			var sellbuyregex = regexStringBundle.getString('sellbuyregex');
			sellbuyregex = new RegExp(sellbuyregex);
			var userleftregex = regexStringBundle.getString('userleftregex');
			userleftregex = new RegExp(userleftregex);
			if(td[0].match(detailregex)) {
				detail = td[0].match(detailregex)[1];
				if(detail.toLowerCase().match(/positive/)) {
					detail = 'positive';
					sorttype = 4;
				} else if(detail.toLowerCase().match(/negative/)) {
					detail = 'negative';
					sorttype = 1;
				} else if(detail.toLowerCase().match(/neutral/)) {
					detail = 'neutral';
					sorttype = 2;
				}
			} else {
				detail = 'withdrawn';
				sorttype = 3;
			}
			comment = td[1].replace(/<td.*?>/,"").replace(/<\/td>/,"");
			try{
				sellbuy = td[2].match(sellbuyregex)[1];
				userLeft = td[2].match(userleftregex)[1];
				sellbuy = sellbuy.replace(/<div.*?><a href=\"http/,"unknown");
				if (sellbuy.match(/Seller/)) {
				    sellbuy = seller;
				} else if (sellbuy.match(/Buyer/)) {
				    sellbuy = buyer;
				} else {
				    sellbuy = '--';
				}
			} catch(e){}
			date = td[3].replace(/<td.*?>/,"").replace(/<\/td>/,"");
			var tmpDate = "";
			if (date.match(/(...)-(\d\d)-(\d\d) (\d\d):(\d\d)/)) {
			    tmpDate = date.match(/(...)-(\d\d)-(\d\d) (\d\d):(\d\d)/);
			    var dateObj = new Date();
			    dateObj.setDate(parseInt(tmpDate[2]));
			    dateObj.setMonth(getMonth(tmpDate[1]));
			    tmpDate[3] = (parseInt(tmpDate[3])>69) ? "19" + tmpDate[3] : "20" + tmpDate[3];
			    dateObj.setFullYear(parseInt(tmpDate[3]));
			    dateObj.setHours(parseInt(tmpDate[4]));
			    dateObj.setMinutes(parseInt(tmpDate[5]));
			    date = localizeDate(dateObj);
			}
			try {
				item = td[5].match(/\(#(\d+)\)/)[1];
			} catch(e){
				item = td[7].replace(/<td.*?>/,"").replace(/<\/td>/,"");
			}
			try {
			    // -- (#1234567890)
				item = item.match(/-- \(\#(\d+)\)/)[1];
			} catch(e){}
			if (item.match(/Private/) || item.match(/--/)) {item = privateAuction;}

			// === add feedback ===	
			var feedback = new Array();
			feedback.push(detail);	// 0
			feedback.push(comment);	// 1
			feedback.push(characteristic == 'sellbuy' ? sellbuy : userLeft); // 2
			feedback.push(date);	// 3
			feedback.push(item);	// 4
			feedback.push(link);	// 5
			feedback.push(sorttype);// 6
			feedback.push(false);	// 7
			addCommentRow(feedback);
			// reset
			detail = "";
			comment = "";
			sellbuy = "";
			userLeft = "";
			date = "";
			item = "";
			link = "";
		}
	} 
} catch(e) {
	log("extractComments: " + e);
}
return true;
}

function getMonth(month) {
    
    if (month == 'Jan') return 0;
    else if (month == 'Feb') return 1;
    else if (month == 'Mar') return 2;
    else if (month == 'Apr') return 3;
    else if (month == 'May') return 4;
    else if (month == 'Jun') return 5;
    else if (month == 'Jul') return 6;
    else if (month == 'Aug') return 7;
    else if (month == 'Sep') return 8;
    else if (month == 'Oct') return 9;
    else if (month == 'Nov') return 10;
    else if (month == 'Dec') return 11;
    
    return -1;
}

function localizeDate(date) {
	tld = getTLD();
    var millis = date.getTime();
	var correction = calculateTimeShift();
	millis += correction;
	date.setTime(millis);
	var day = date.getDate();
	if (day < 10) { day = "0" + day; }
	var month = date.getMonth() + 1;
	if (month < 10) { month = "0" + month; }
	var year = date.getYear();
	if (year >= 100) { year -= 100; }
	if (year < 10) { year = "0" + year; }
    var localeDate = "";
    if ((tld == 'co.uk') || (tld == 'fr') || (tld == 'it')) {
        localeDate = day + "-" + months[date.getMonth()] + "-" + year;
    } else if (tld == 'de') {
        localeDate = day + "." + month + "." + year;
    } else if ((tld == 'es') || (tld == 'nl')) {
        localeDate = day + "-" + months[date.getMonth()].toLowerCase() + "-" +year;
    } else {
        localeDate = months[date.getMonth()] + "-" + day + "-" + year;
    }
	var hours = date.getHours();
	if (hours < 10) { hours = "0" + hours; }
	var minutes = date.getMinutes();
	if (minutes < 10) { minutes = "0" + minutes; }
	localeDate += " " + hours + ":" + minutes;
    return localeDate;
}

function calculateTimeShift() {
	var l = prefService.getCharPref("general.useragent.locale");
	l = (l.length > 2) ? l.substring(3).toLowerCase() : l.toLowerCase();
	var correction = 0;
	switch (l) {
		case "at": // +9h
			correction = 32400;
			break;
		case "ch": // +9h
			correction = 32400;
			break;
		case "de": // +9h
			correction = 32400;
			break;
		case "au": // +17h
			correction = 61200;
			break;
		case "ca": // +3h
			correction = 10800;
			break;
		case "gb": // +8h
			correction = 28800;
			break;
		case "ie": // +8h
			correction = 28800;
			break;
		case "in": // +13h
			correction = 46800;
			break;
		case "sg": // +6h
			correction = 21600;
			break;
		case "es": // +9h
			correction = 32400;
			break;
		case "it": // +9h
			correction = 32400;
			break;
		case "fr": // +9h
			correction = 32400;
			break;
		case "be": // +9h
			correction = 32400;
			break;
		case "nl": // +9h
			correction = 32400;
			break;
		case "pl": // +9h
			correction = 32400;
			break;
		case "cn": // +15h
			correction = 54000;
			break;
		default: // eBay headquarter
			correction = 0;
			break;
	}
	correction = correction * 1000;
	return correction;
}

function addCommentRow(feedback) {

	addItem([feedback[0],feedback[1],feedback[2],feedback[3],feedback[4],feedback[5],feedback[6],feedback[7]]);
	fbCount++;
}

function processRowSelection(row) {
	
	var table = getDataTable();
	if(table[row]) {
		var item = table[row][4];
		if(item != privateAuction) {
		    tld = getTLD();
			var link = "http://cgi.ebay." + tld + "/ws/eBayISAPI.dll?ViewItem&item=" + item;
			topWin = windowMediator.getMostRecentWindow("navigator:browser");
			browser = topWin.getBrowser();
			if(link.length > 5) {
				// add a new tab and open item link
				if(itemTab) {
					browser.selectedTab = itemTab;
					browser.loadURI(link);
				} else {
					itemTab = browser.addTab(link);
					browser.selectedTab = itemTab;
				}
			} else {
			    tmp = document.getElementById('info_state').getAttribute('value');
				setState(itemnotavailable);
			}
		} else {
		    setState(noitemview);// TODO
		}
	}
}

function reset() {
	numberOfPages = 1;
	statePanel = null;
	fbUrl = "";
	pagesContent = "";
	fbCount = 0;
	http_request_content = false;
	type = "";
	firstPageProcessed = false;
	allFinished = false;
	currentPage = 1;
	itemTab = null;
	tmp = "";
	try {
	    resetTree();
	} catch(e) {}
}

function setState(text) {
    switchStatePanel('info');
	if(text == itemnotavailable) {
		window.setTimeout("setState()", 1000);
	}
	statePanel = document.getElementById('info_state');
	if(statePanel) {
		if(text) {
			statePanel.setAttribute('value', text);
			notify(text);
		} else {
			statePanel.setAttribute('value', tmp);
			notify(tmp);
		}
		return true;
	}
	return false;
}

function setProgressbar(value) {
	
	progress = document.getElementById('progress_state');
	progress.setAttribute('value', value);
}

function switchStatePanel(type) {
	
	progress = document.getElementById('progress_state');
	statePanel = document.getElementById('info_state');
	var sp1 = document.getElementById('sp1');
	var sp2 = document.getElementById('sp2');
	if(type == 'progress') {
		progress.hidden = false;
		sp1.hidden = true;
		statePanel.hidden = true;
		sp2.hidden = true;
	} else if(type == 'info') {
		progress.hidden = true;
		sp1.hidden = false;
		statePanel.hidden = false;
		sp2.hidden = false;
	}
} 

function openOptionsWindow() {
	if(!(optWnd && optWnd.document)) 
		optWnd = openDialog("chrome://feedbackfox/content/options.xul","","chrome,titlebar,toolbar,centerscreen,dialog=no");
	else 
		optWnd.focus();
}

function openHelpWindow() {
	openHelp('introduction','chrome://feedbackfox/content/feedbackfoxhelp.rdf');
}

window.addEventListener('load', init, false);
window.addEventListener('load', registerContextMenuListener, true);